"use strict";

exports.__esModule = true;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require("react-dom");

var _reactDom2 = _interopRequireDefault(_reactDom);

var _componentPlayground = require("component-playground");

var _componentPlayground2 = _interopRequireDefault(_componentPlayground);

var _objectAssign = require("object-assign");

var _objectAssign2 = _interopRequireDefault(_objectAssign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EMPTY_ARRAY = [];

var getCodeText = function getCodeText(example, localScope) {
  if (!example.noRender) {
    return example.code;
  }

  var scope = (0, _objectAssign2.default)(localScope, example.extraScope);
  if (!(scope.IntlProvider && scope.locale && scope.messages)) {
    return example.code;
  }

  return ["<IntlProvider locale={locale} messages={messages}>\n", " " + example.code, "</IntlProvider>\n"].join("");
};

var ElectrodeDemoIndex = function (_Component) {
  (0, _inherits3.default)(ElectrodeDemoIndex, _Component);

  function ElectrodeDemoIndex(props) {
    (0, _classCallCheck3.default)(this, ElectrodeDemoIndex);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

    _this.state = {
      libraryScope: props.libraryScope,
      components: props.components
    };
    return _this;
  }

  ElectrodeDemoIndex.prototype.componentWillReceiveProps = function componentWillReceiveProps(props) {
    if (props.libraryScope !== this.state.libraryScope || props.components !== this.state.components) {
      this.setState({
        libraryScope: props.libraryScope,
        components: props.components
      });
    }
  };

  ElectrodeDemoIndex.prototype.render = function render() {

    var localScope = (0, _objectAssign2.default)({ React: _react2.default, ReactDOM: _reactDom2.default }, this.props.scope || {}, this.state.libraryScope);
    var components = this.state.components || EMPTY_ARRAY;

    return _react2.default.createElement(
      "div",
      { className: "component-documentation" },
      components.map(function (component, index) {
        var title = component.title,
            examples = component.examples;


        return _react2.default.createElement(
          "div",
          { key: index },
          _react2.default.createElement(
            "h3",
            { id: title },
            title
          ),
          examples.map(function (example, subindex) {
            return _react2.default.createElement(
              "div",
              { className: "component-section", key: subindex },
              example.title ? _react2.default.createElement("a", { name: example.title.replace(/\s/g, "").toLowerCase() }) : null,
              example.title ? _react2.default.createElement(
                "h4",
                null,
                example.title
              ) : null,
              _react2.default.createElement(_componentPlayground2.default, { codeText: getCodeText(example, localScope),
                scope: (0, _objectAssign2.default)(localScope, example.extraScope || {}),
                noRender: example.noRender })
            );
          })
        );
      })
    );
  };

  return ElectrodeDemoIndex;
}(_react.Component);

exports.default = ElectrodeDemoIndex;


ElectrodeDemoIndex.propTypes = {
  scope: _propTypes2.default.object,
  libraryScope: _propTypes2.default.object,
  components: _propTypes2.default.array
};